package 
{
	import net.flashpunk.graphics.Text;
	import net.flashpunk.World;
	import net.flashpunk.Entity;
	import net.flashpunk.FP;
	import net.flashpunk.utils.Input;
	import net.flashpunk.utils.Key;
	import flash.geom.Point;
	import net.flashpunk.utils.Draw;
	/**
	 * ...
	 * @author Time
	 */
	public class Game extends World
	{
		public static const mouseBreakRadius:int = 100;
		public static const blackHoleKey:int = Key.Z;
		public static const breakKey:int = Key.X;
		public static const pushKey:int = Key.C;
		public static const gravityKey:int = Key.G;
		
		public static var gravity:Boolean = false;
		
		private var controlsText:Text;
		
		public function Game() 
		{
			//FP.console.enable();
			super();
		}
		override public function begin():void
		{
			super.begin();
			for (var i:int = 0; i < 100; i++)
			{
				add(new Node((i + 2 / (i+1) + Math.pow(i,2) + 600/(Math.pow(i-50, 2)+1))%FP.width, (i + 2 / (i+1) - Math.pow(i,2) - 200/(Math.pow(i-50, 2)+1)+Math.pow(i, 3)*10000)%FP.height));
				//add(new Node((i % 10)/9 * FP.width, Math.floor(i / 9) / 9 * FP.height));
			}
			controlsText = new Text("Z+Click: Pull\nC+Click: Push\nX+Click: Break\nG: Toggle Gravity");
			/*
			var d:int = 20;
			var n:Node;
			add(n = new Node(FP.width / 2 - d, FP.height / 2 - d));
			add(new Node(FP.width / 2 - d, FP.height / 2 + d));
			add(new Node(FP.width / 2 + d, FP.height / 2 - d));
			add(new Node(FP.width / 2 + d, FP.height / 2 + d));
			
			n.p.x = 1 / n.m;*/
		}
		override public function update():void
		{
			var nodes:Vector.<Node> = new Vector.<Node>();
			getClass(Node, nodes);
			
			if (Input.released(gravityKey))
			{
				gravity = !gravity;
			}
			if (Input.mouseDown && (Input.check(blackHoleKey) || Input.check(pushKey)))
			{
				for (var i:int = 0; i < nodes.length; i++)
				{
					var a:Number = Math.atan2(Input.mouseY - nodes[i].y, Input.mouseX - nodes[i].x) + (Math.PI * int(Input.check(pushKey)));
					var maxD:int = FP.distance(0, 0, FP.width, FP.height)/2;
					var d:int = FP.distance(nodes[i].x, nodes[i].y, Input.mouseX, Input.mouseY);
					
					var f:int = 30 * Math.max(1 - d / maxD, 0);
					nodes[i].p = new Point(nodes[i].p.x + f * Math.cos(a), nodes[i].p.y + f * Math.sin(a));
				}
			}
			super.update();
			for (i = 0; i < nodes.length; i++)
			{
				nodes[i].move();
			}
			//nodes[0].color = 0xFF0000;
			//FP.console.log(nodes[0].nodes.length, nodes[0].rods.length);
		}
		override public function render():void
		{
			super.render();
			
			controlsText.color = 0x000000;
			controlsText.render(new Point(FP.camera.x + 1, FP.camera.y + FP.height - controlsText.height - 3), FP.camera);
			controlsText.render(new Point(FP.camera.x + 1, FP.camera.y + FP.height - controlsText.height - 1), FP.camera);
			controlsText.render(new Point(FP.camera.x + 3, FP.camera.y + FP.height - controlsText.height - 3), FP.camera);
			controlsText.render(new Point(FP.camera.x + 3, FP.camera.y + FP.height - controlsText.height - 1), FP.camera);
			
			controlsText.color = 0xFFFFFF;
			controlsText.render(new Point(FP.camera.x + 2, FP.camera.y + FP.height - controlsText.height - 2), FP.camera);
		}
		
	}

}