package  
{
	import flash.geom.Point;
	import net.flashpunk.Entity;
	import net.flashpunk.utils.Draw;
	import net.flashpunk.FP;
	import net.flashpunk.utils.Input;
	/**
	 * ...
	 * @author Time
	 */
	public class Node extends Entity
	{
		public static const dampener:Number = 1;
		public static const maxP:int = 100;
		public static const conRadius:int = 20;
		
		public static const g:Number = 0.01;
		
		public var nodes:Vector.<Node> = new Vector.<Node>();
		public var rods:Vector.<Rod> = new Vector.<Rod>();
		
		public var p:Point;
		public var m:int = 10 + 90 * Math.random();
		public var radius:int = Math.sqrt(m);
		public var color:uint = 0x00FF00;
		
		public function Node(_x:int, _y:int) 
		{
			super(_x, _y);
			p = new Point(10*Math.cos(Math.atan2(FP.height/2-y,FP.width/2-x)),10*Math.sin(Math.atan2(FP.height/2-y,FP.width/2-x)));
		}
		
		public function move():void
		{
			contract();
			
			if (Game.gravity)
			{
				p.y += g * m;
			}
			
			p.x *= dampener;
			p.y *= dampener;
			
			if (p.length > maxP)
			{
				p.normalize(maxP);
			}
			
			x += p.x / m;
			y += p.y / m;
			
			if (x > FP.width)
			{
				p.x = -Math.abs(p.x);
			}
			else if (x < 0)
			{
				p.x = Math.abs(p.x);
			}
			if (y > FP.height)
			{
				p.y = -Math.abs(p.y);
			}
			else if (y < 0)
			{
				p.y = Math.abs(p.y);
			}
		}
		
		override public function update():void
		{
			addNodes();
		}
		
		override public function render():void
		{
			Draw.circlePlus(x, y, radius, color);
		}
		
		public function contract():void
		{
			for (var i:int = 0; i < rods.length; i++)
			{
				var a:Number = Math.atan2(y - rods[i].y, x - rods[i].x);
				if (!isNaN(rods[i].f))
				{
					p.x += rods[i].f * Math.cos(a);
					p.y += rods[i].f * Math.sin(a);
				}
			}
		}
		
		public function addNodes(startIndex:int=0):void
		{
			var allNodes:Vector.<Node> = new Vector.<Node>();
			FP.world.getClass(Node, allNodes);
			
			for (var i:int = startIndex; i < allNodes.length; i++)
			{
				var conToCurrentNode:Boolean = (allNodes[i] == this);
				for (var j:int = 0; j < nodes.length; j++)
				{
					if (allNodes[i] == nodes[j])
					{
						conToCurrentNode = true;
						break;
					}
				}
				if (conToCurrentNode)
				{
					continue;
				}
				var d:Number = FP.distance(x, y, allNodes[i].x, allNodes[i].y);
				if (d <= conRadius)
				{
					nodes.push(allNodes[i]);
					allNodes[i].nodes.push(this);
					var rod:Rod;
					FP.world.add(rod = new Rod(this, nodes[nodes.length - 1]));
				}
			}
		}
		
		public function removeRod(r:Rod):void
		{
			for (var i:int = 0; i < rods.length; i++)
			{
				if (rods[i] == r)
				{
					for (var j:int = 0; j < r.nodes.length; j++)
					{
						for (var k:int = 0; k < nodes.length; k++)
						{
							if (nodes[k] == r.nodes[j])
							{
								nodes.splice(k, 1);
								break;
							}
						}
					}
					rods.splice(i, 1);
					break;
				}
			}
		}
		
	}

}