package  
{
	import net.flashpunk.Entity;
	import net.flashpunk.FP;
	import net.flashpunk.utils.Draw;
	import net.flashpunk.utils.Input;
	/**
	 * ...
	 * @author Time
	 */
	public class Rod extends Entity
	{
		public static const coeffPull:Number = 100;
		
		public var nodes:Vector.<Node> = new Vector.<Node>();
		private var length:int;
		
		public var f:Number = 0;
		
		public function Rod(_n0:Node, _n1:Node) 
		{
			nodes.push(_n0, _n1);
			for (var i:int = 0; i < nodes.length; i++)
			{
				nodes[i].rods.push(this);
			}
			length = Node.conRadius;//FP.distance(nodes[0].x, nodes[0].y, nodes[1].x, nodes[1].y);
		}
		
		override public function removed():void
		{
			for (var i:int = 0; i < nodes.length; i++)
			{
				nodes[i].removeRod(this);
			}
		}
		
		override public function update():void
		{
			if (nodes.length == 0 || Math.abs(f) >= coeffPull/2 || (FP.distance(x, y, Input.mouseX, Input.mouseY) < Game.mouseBreakRadius && Input.mouseDown && Input.check(Game.breakKey)))
			{
				FP.world.remove(this);
			}
			if (nodes[0] && nodes[1])
			{
				var d:Number = FP.distance(nodes[0].x, nodes[0].y, nodes[1].x, nodes[1].y);
				f = coeffPull*(length - d) / length;
				centerRod();
			}
		}
		
		override public function render():void
		{
			if (nodes[0] && nodes[1])
			{
				Draw.line(nodes[0].x, nodes[0].y, nodes[1].x, nodes[1].y);
			}
		}
		
		public function centerRod():void
		{
			x = 0;
			y = 0;
			var totMass:int = 0;
			for (var i:int = 0; i < nodes.length; i++)
			{
				x += nodes[i].x * nodes[i].m;
				y += nodes[i].y * nodes[i].m;
				totMass += nodes[i].m;
			}
			x /= totMass;
			y /= totMass;
		}
		
	}

}